## org.mortbay.jetty.servlet
Class ServletHttpRequest

    java.lang.Object
      |
      +--org.mortbay.jetty.servlet.ServletHttpRequest

All Implemented Interfaces:
  HttpServletRequest, ServletRequest

public class ServletHttpRequest
extends java.lang.Object
implements HttpServletRequest

Servlet Request Wrapper. This class wraps a Jetty HTTP request as a 2.2 Servlet request.

Note that this wrapper is not synchronized and if a request is to be operated on by multiple threads, then higher level synchronizations may be required.

Version:
  $Id: ServletHttpRequest.java,v 1.45.2.2 2003/10/16 23:24:26 gregwilkins Exp $
Author:
  Greg Wilkins (gregw)

Field Summary
`static java.lang.String` `__SESSIONID_COOKIE`
`static java.lang.String` `__SESSIONID_NONE`
`static java.lang.String` `__SESSIONID_NOT_CHECKED`
`static java.lang.String` `__SESSIONID_URL`

Fields inherited from interface javax.servlet.http.HttpServletRequest
`BASIC_AUTH, CLIENT_CERT_AUTH, DIGEST_AUTH, FORM_AUTH`

Method Summary
`java.lang.Object` `getAttribute(java.lang.String name)` Returns the value of the named attribute as an `Object`, or `null` if no attribute of the given name exists.
`java.util.Enumeration` `getAttributeNames()` Returns an `Enumeration` containing the names of the attributes available to this request.
`java.lang.String` `getAuthType()` Returns the name of the authentication scheme used to protect the servlet.
`java.lang.String` `getCharacterEncoding()` Returns the name of the character encoding used in the body of this request.
`int` `getContentLength()` Returns the length, in bytes, of the request body and made available by the input stream, or -1 if the length is not known.
`java.lang.String` `getContentType()` Returns the MIME type of the body of the request, or `null` if the type is not known.
`java.lang.String` `getContextPath()` Returns the portion of the request URI that indicates the context of the request.
`Cookie[]` `getCookies()` Returns an array containing all of the `Cookie` objects the client sent with this request.
`long` `getDateHeader(java.lang.String name)` Returns the value of the specified request header as a `long` value that represents a `Date` object.
`java.lang.String` `getHeader(java.lang.String name)` Returns the value of the specified request header as a `String`.
`java.util.Enumeration` `getHeaderNames()` Returns an enumeration of all the header names this request contains.
`java.util.Enumeration` `getHeaders(java.lang.String s)` Returns all the values of the specified request header as an `Enumeration` of `String` objects.
`ServletInputStream` `getInputStream()` Retrieves the body of the request as binary data using a `ServletInputStream`.
`int` `getIntHeader(java.lang.String name)` Returns the value of the specified request header as an `int`.
`java.util.Locale` `getLocale()` Returns the preferred `Locale` that the client will accept content in, based on the Accept-Language header.
`java.util.Enumeration` `getLocales()` Returns an `Enumeration` of `Locale` objects indicating, in decreasing order starting with the preferred locale, the locales that are acceptable to the client based on the Accept-Language header.
`java.lang.String` `getMethod()` Returns the name of the HTTP method with which this request was made, for example, GET, POST, or PUT.
`java.lang.String` `getParameter(java.lang.String name)` Returns the value of a request parameter as a `String`, or `null` if the parameter does not exist.
`java.util.Map` `getParameterMap()` This method is not recommended as it forces the generation of a non-optimal data structure.
`java.util.Enumeration` `getParameterNames()` Returns an `Enumeration` of `String` objects containing the names of the parameters contained in this request.
`java.lang.String[]` `getParameterValues(java.lang.String name)` Returns an array of `String` objects containing all of the values the given request parameter has, or `null` if the parameter does not exist.
`java.lang.String` `getPathInfo()` Returns any extra path information associated with the URL the client sent when it made this request.
`java.lang.String` `getPathTranslated()` Returns any extra path information after the servlet name but before the query string, and translates it to a real path.
`java.lang.String` `getProtocol()` Returns the name and version of the protocol the request uses in the form protocol/majorVersion.minorVersion, for example, HTTP/1.1.
`java.lang.String` `getQueryString()` Returns the query string that is contained in the request URL after the path.
`java.io.BufferedReader` `getReader()` Retrieves the body of the request as character data using a `BufferedReader`.
`java.lang.String` `getRealPath(java.lang.String path)` Deprecated. As of Version 2.1 of the Java Servlet API, use `ServletContext.getRealPath(java.lang.String)` instead.
`java.lang.String` `getRemoteAddr()` Returns the Internet Protocol (IP) address of the client that sent the request.
`java.lang.String` `getRemoteHost()` Returns the fully qualified name of the client that sent the request.
`java.lang.String` `getRemoteUser()` Returns the login of the user making this request, if the user has been authenticated, or `null` if the user has not been authenticated.
`RequestDispatcher` `getRequestDispatcher(java.lang.String url)` Returns a `RequestDispatcher` object that acts as a wrapper for the resource located at the given path.
`java.lang.String` `getRequestedSessionId()` Returns the session ID specified by the client.
`java.lang.String` `getRequestURI()` Returns the part of this request's URL from the protocol name up to the query string in the first line of the HTTP request.
`java.lang.StringBuffer` `getRequestURL()` Reconstructs the URL the client used to make the request.
`java.lang.String` `getScheme()` Returns the name of the scheme used to make this request, for example, `http`, `https`, or `ftp`.
`java.lang.String` `getServerName()` Returns the host name of the server that received the request.
`int` `getServerPort()` Returns the port number on which this request was received.
`ServletHttpResponse` `getServletHttpResponse()`
`java.lang.String` `getServletPath()` Returns the part of this request's URL that calls the servlet.
`HttpSession` `getSession()` Returns the current session associated with this request, or if the request does not have a session, creates one.
`HttpSession` `getSession(boolean create)` Returns the current `HttpSession` associated with this request or, if if there is no current session and `create` is true, returns a new session.
`java.security.Principal` `getUserPrincipal()` Returns a `java.security.Principal` object containing the name of the current authenticated user.
`boolean` `isRequestedSessionIdFromCookie()` Checks whether the requested session ID came in as a cookie.
`boolean` `isRequestedSessionIdFromUrl()` Deprecated.
`boolean` `isRequestedSessionIdFromURL()` Checks whether the requested session ID came in as part of the request URL.
`boolean` `isRequestedSessionIdValid()` Checks whether the requested session ID is still valid.
`boolean` `isSecure()` Returns a boolean indicating whether this request was made using a secure channel, such as HTTPS.
`boolean` `isUserInRole(java.lang.String role)` Returns a boolean indicating whether the authenticated user is included in the specified logical "role".
`void` `removeAttribute(java.lang.String name)` Removes an attribute from this request.
`void` `setAttribute(java.lang.String name, java.lang.Object value)` Stores an attribute in this request.
`void` `setCharacterEncoding(java.lang.String encoding)` Overrides the name of the character encoding used in the body of this request.
`java.lang.String` `toString()`
`static ServletHttpRequest` `unwrap(ServletRequest request)` Unwrap a ServletRequest.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### __SESSIONID_NOT_CHECKED

    public static final java.lang.String __SESSIONID_NOT_CHECKED

See Also:
  Constant Field Values

### __SESSIONID_URL

    public static final java.lang.String __SESSIONID_URL

See Also:
  Constant Field Values

### __SESSIONID_COOKIE

    public static final java.lang.String __SESSIONID_COOKIE

See Also:
  Constant Field Values

### __SESSIONID_NONE

    public static final java.lang.String __SESSIONID_NONE

See Also:
  Constant Field Values

Method Detail

### getServletHttpResponse

    public ServletHttpResponse getServletHttpResponse()

### getLocale

    public java.util.Locale getLocale()

  Description copied from interface: `ServletRequest`
  Returns the preferred `Locale` that the client will accept content in, based on the Accept-Language header. If the client request doesn't provide an Accept-Language header, this method returns the default locale for the server.

  Specified by:
    `getLocale` in interface `ServletRequest`
  Returns:
    the preferred `Locale` for the client

### getLocales

    public java.util.Enumeration getLocales()

  Description copied from interface: `ServletRequest`
  Returns an `Enumeration` of `Locale` objects indicating, in decreasing order starting with the preferred locale, the locales that are acceptable to the client based on the Accept-Language header. If the client request doesn't provide an Accept-Language header, this method returns an `Enumeration` containing one `Locale`, the default locale for the server.

  Specified by:
    `getLocales` in interface `ServletRequest`
  Returns:
    an `Enumeration` of preferred `Locale` objects for the client

### isSecure

    public boolean isSecure()

  Description copied from interface: `ServletRequest`
  Returns a boolean indicating whether this request was made using a secure channel, such as HTTPS.

  Specified by:
    `isSecure` in interface `ServletRequest`
  Returns:
    a boolean indicating if the request was made using a secure channel

### getCookies

    public Cookie[] getCookies()

  Description copied from interface: `HttpServletRequest`
  Returns an array containing all of the `Cookie` objects the client sent with this request. This method returns `null` if no cookies were sent.

  Specified by:
    `getCookies` in interface `HttpServletRequest`
  Returns:
    an array of all the `Cookies` included with this request, or `null` if the request has no cookies

### getDateHeader

    public long getDateHeader(java.lang.String name)

  Description copied from interface: `HttpServletRequest`
  Returns the value of the specified request header as a `long` value that represents a `Date` object. Use this method with headers that contain dates, such as `If-Modified-Since`.

  The date is returned as the number of milliseconds since January 1, 1970 GMT. The header name is case insensitive.

  If the request did not have a header of the specified name, this method returns -1. If the header can't be converted to a date, the method throws an `IllegalArgumentException`.

  Specified by:
    `getDateHeader` in interface `HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the name of the header
  Returns:
    a `long` value representing the date specified in the header expressed as the number of milliseconds since January 1, 1970 GMT, or -1 if the named header was not included with the reqest

### getHeaderNames

    public java.util.Enumeration getHeaderNames()

  Description copied from interface: `HttpServletRequest`
  Returns an enumeration of all the header names this request contains. If the request has no headers, this method returns an empty enumeration.

  Some servlet containers do not allow do not allow servlets to access headers using this method, in which case this method returns `null`

  Specified by:
    `getHeaderNames` in interface `HttpServletRequest`
  Returns:
    an enumeration of all the header names sent with this request; if the request has no headers, an empty enumeration; if the servlet container does not allow servlets to use this method, `null`

### getHeader

    public java.lang.String getHeader(java.lang.String name)

  Description copied from interface: `HttpServletRequest`
  Returns the value of the specified request header as a `String`. If the request did not include a header of the specified name, this method returns `null`. The header name is case insensitive. You can use this method with any request header.

  Specified by:
    `getHeader` in interface `HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the header name
  Returns:
    a `String` containing the value of the requested header, or `null` if the request does not have a header of that name

### getHeaders

    public java.util.Enumeration getHeaders(java.lang.String s)

  Description copied from interface: `HttpServletRequest`
  Returns all the values of the specified request header as an `Enumeration` of `String` objects.

  Some headers, such as `Accept-Language` can be sent by clients as several headers each with a different value rather than sending the header as a comma separated list.

  If the request did not include any headers of the specified name, this method returns an empty `Enumeration`. The header name is case insensitive. You can use this method with any request header.

  Specified by:
    `getHeaders` in interface `HttpServletRequest`
  Parameters:
    `s` - a `String` specifying the header name
  Returns:
    an `Enumeration` containing the values of the requested header. If the request does not have any headers of that name return an empty enumeration. If the container does not allow access to header information, return null

### getIntHeader

    public int getIntHeader(java.lang.String name)
                     throws java.lang.NumberFormatException

  Description copied from interface: `HttpServletRequest`
  Returns the value of the specified request header as an `int`. If the request does not have a header of the specified name, this method returns -1. If the header cannot be converted to an integer, this method throws a `NumberFormatException`.

  The header name is case insensitive.

  Specified by:
    `getIntHeader` in interface `HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the name of a request header
  Returns:
    an integer expressing the value of the request header or -1 if the request doesn't have a header of this name
  Throws:
    `java.lang.NumberFormatException` - If the header value can't be converted to an `int`

### getMethod

    public java.lang.String getMethod()

  Description copied from interface: `HttpServletRequest`
  Returns the name of the HTTP method with which this request was made, for example, GET, POST, or PUT. Same as the value of the CGI variable REQUEST_METHOD.

  Specified by:
    `getMethod` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the name of the method with which this request was made

### getContextPath

    public java.lang.String getContextPath()

  Description copied from interface: `HttpServletRequest`
  Returns the portion of the request URI that indicates the context of the request. The context path always comes first in a request URI. The path starts with a "/" character but does not end with a "/" character. For servlets in the default (root) context, this method returns "". The container does not decode this string.

  Specified by:
    `getContextPath` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the portion of the request URI that indicates the context of the request

### getPathInfo

    public java.lang.String getPathInfo()

  Description copied from interface: `HttpServletRequest`
  Returns any extra path information associated with the URL the client sent when it made this request. The extra path information follows the servlet path but precedes the query string. This method returns `null` if there was no extra path information.

  Same as the value of the CGI variable PATH_INFO.

  Specified by:
    `getPathInfo` in interface `HttpServletRequest`
  Returns:
    a `String`, decoded by the web container, specifying extra path information that comes after the servlet path but before the query string in the request URL; or `null` if the URL does not have any extra path information

### getPathTranslated

    public java.lang.String getPathTranslated()

  Description copied from interface: `HttpServletRequest`
  Returns any extra path information after the servlet name but before the query string, and translates it to a real path. Same as the value of the CGI variable PATH_TRANSLATED.

  If the URL does not have any extra path information, this method returns `null`. The web container does not decode thins string.

  Specified by:
    `getPathTranslated` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the real path, or `null` if the URL does not have any extra path information

### getQueryString

    public java.lang.String getQueryString()

  Description copied from interface: `HttpServletRequest`
  Returns the query string that is contained in the request URL after the path. This method returns `null` if the URL does not have a query string. Same as the value of the CGI variable QUERY_STRING.

  Specified by:
    `getQueryString` in interface `HttpServletRequest`
  Returns:
    a `String` containing the query string or `null` if the URL contains no query string. The value is not decoded by the container.

### getAuthType

    public java.lang.String getAuthType()

  Description copied from interface: `HttpServletRequest`
  Returns the name of the authentication scheme used to protect the servlet. All servlet containers support basic, form and client certificate authentication, and may additionally support digest authentication. If the servlet is not authenticated `null` is returned.

  Same as the value of the CGI variable AUTH_TYPE.

  Specified by:
    `getAuthType` in interface `HttpServletRequest`
  Returns:
    one of the static members BASIC_AUTH, FORM_AUTH, CLIENT_CERT_AUTH, DIGEST_AUTH (suitable for == comparison) indicating the authentication scheme, or `null` if the request was not authenticated.

### getRemoteUser

    public java.lang.String getRemoteUser()

  Description copied from interface: `HttpServletRequest`
  Returns the login of the user making this request, if the user has been authenticated, or `null` if the user has not been authenticated. Whether the user name is sent with each subsequent request depends on the browser and type of authentication. Same as the value of the CGI variable REMOTE_USER.

  Specified by:
    `getRemoteUser` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the login of the user making this request, or `null`

  ### isUserInRole

      public boolean isUserInRole(java.lang.String role)

    Description copied from interface: `HttpServletRequest`
    Returns a boolean indicating whether the authenticated user is included in the specified logical "role". Roles and role membership can be defined using deployment descriptors. If the user has not been authenticated, the method returns `false`.

    Specified by:
      `isUserInRole` in interface `HttpServletRequest`
    Parameters:
      `role` - a `String` specifying the name of the role
    Returns:
      a `boolean` indicating whether the user making this request belongs to a given role; `false` if the user has not been authenticated

  ### getUserPrincipal

      public java.security.Principal getUserPrincipal()

    Description copied from interface: `HttpServletRequest`
    Returns a `java.security.Principal` object containing the name of the current authenticated user. If the user has not been authenticated, the method returns `null`.

    Specified by:
      `getUserPrincipal` in interface `HttpServletRequest`
    Returns:
      a `java.security.Principal` containing the name of the user making this request; `null` if the user has not been authenticated

  ### getRequestedSessionId

      public java.lang.String getRequestedSessionId()

    Description copied from interface: `HttpServletRequest`
    Returns the session ID specified by the client. This may not be the same as the ID of the actual session in use. For example, if the request specified an old (expired) session ID and the server has started a new session, this method gets a new session with a new ID. If the request did not specify a session ID, this method returns `null`.

    Specified by:
      `getRequestedSessionId` in interface `HttpServletRequest`
    Returns:
      a `String` specifying the session ID, or `null` if the request did not specify a session ID
    See Also:
      `HttpServletRequest.isRequestedSessionIdValid()`

  ### getRequestURI

      public java.lang.String getRequestURI()

    Description copied from interface: `HttpServletRequest`
    Returns the part of this request's URL from the protocol name up to the query string in the first line of the HTTP request. The web container does not decode this String. For example:

    First line of HTTP request | Returned Value
    --- | ---
    POST /some/path.html HTTP/1.1 |  | /some/path.html
    GET http://foo.bar/a.html HTTP/1.0 |  | /a.html
    HEAD /xyz?a=b HTTP/1.1 |  | /xyz

    To reconstruct an URL with a scheme and host, use `HttpUtils.getRequestURL(javax.servlet.http.HttpServletRequest)`.

    Specified by:
      `getRequestURI` in interface `HttpServletRequest`
    Returns:
      a `String` containing the part of the URL from the protocol name up to the query string
    See Also:
      `HttpUtils.getRequestURL(javax.servlet.http.HttpServletRequest)`

  ### getRequestURL

      public java.lang.StringBuffer getRequestURL()

    Description copied from interface: `HttpServletRequest`
    Reconstructs the URL the client used to make the request. The returned URL contains a protocol, server name, port number, and server path, but it does not include query string parameters.

    Because this method returns a `StringBuffer`, not a string, you can modify the URL easily, for example, to append query parameters.

    This method is useful for creating redirect messages and for reporting errors.

    Specified by:
      `getRequestURL` in interface `HttpServletRequest`
    Returns:
      a `StringBuffer` object containing the reconstructed URL

  ### getServletPath

      public java.lang.String getServletPath()

    Description copied from interface: `HttpServletRequest`
    Returns the part of this request's URL that calls the servlet. This includes either the servlet name or a path to the servlet, but does not include any extra path information or a query string. Same as the value of the CGI variable SCRIPT_NAME.

    Specified by:
      `getServletPath` in interface `HttpServletRequest`
    Returns:
      a `String` containing the name or path of the servlet being called, as specified in the request URL, decoded.

  ### getSession

      public HttpSession getSession(boolean create)

    Description copied from interface: `HttpServletRequest`
    Returns the current `HttpSession` associated with this request or, if if there is no current session and `create` is true, returns a new session.

    If `create` is `false` and the request has no valid `HttpSession`, this method returns `null`.

    To make sure the session is properly maintained, you must call this method before the response is committed. If the container is using cookies to maintain session integrity and is asked to create a new session when the response is committed, an IllegalStateException is thrown.

    Specified by:
      `getSession` in interface `HttpServletRequest`
    Returns:
      the `HttpSession` associated with this request or `null` if `create` is `false` and the request has no valid session
    See Also:
      `HttpServletRequest.getSession()`

  ### getSession

      public HttpSession getSession()

    Description copied from interface: `HttpServletRequest`
    Returns the current session associated with this request, or if the request does not have a session, creates one.

    Specified by:
      `getSession` in interface `HttpServletRequest`
    Returns:
      the `HttpSession` associated with this request
    See Also:
      `HttpServletRequest.getSession(boolean)`

  ### isRequestedSessionIdValid

      public boolean isRequestedSessionIdValid()

    Description copied from interface: `HttpServletRequest`
    Checks whether the requested session ID is still valid.

    Specified by:
      `isRequestedSessionIdValid` in interface `HttpServletRequest`
    Returns:
      `true` if this request has an id for a valid session in the current session context; `false` otherwise
    See Also:
      `HttpServletRequest.getRequestedSessionId()`, `HttpServletRequest.getSession(boolean)`, `HttpSessionContext`

  ### isRequestedSessionIdFromCookie

      public boolean isRequestedSessionIdFromCookie()

    Description copied from interface: `HttpServletRequest`
    Checks whether the requested session ID came in as a cookie.

    Specified by:
      `isRequestedSessionIdFromCookie` in interface `HttpServletRequest`
    Returns:
      `true` if the session ID came in as a cookie; otherwise, `false`
    See Also:
      `HttpServletRequest.getSession(boolean)`

  ### isRequestedSessionIdFromURL

      public boolean isRequestedSessionIdFromURL()

    Description copied from interface: `HttpServletRequest`
    Checks whether the requested session ID came in as part of the request URL.

    Specified by:
      `isRequestedSessionIdFromURL` in interface `HttpServletRequest`
    Returns:
      `true` if the session ID came in as part of a URL; otherwise, `false`
    See Also:
      `HttpServletRequest.getSession(boolean)`

  ### isRequestedSessionIdFromUrl

      public boolean isRequestedSessionIdFromUrl()

    Deprecated.

    Specified by:
      `isRequestedSessionIdFromUrl` in interface `HttpServletRequest`

  ### getAttributeNames

      public java.util.Enumeration getAttributeNames()

    Description copied from interface: `ServletRequest`
    Returns an `Enumeration` containing the names of the attributes available to this request. This method returns an empty `Enumeration` if the request has no attributes available to it.

    Specified by:
      `getAttributeNames` in interface `ServletRequest`
    Returns:
      an `Enumeration` of strings containing the names of the request's attributes

  ### getAttribute

      public java.lang.Object getAttribute(java.lang.String name)

    Description copied from interface: `ServletRequest`
    Returns the value of the named attribute as an `Object`, or `null` if no attribute of the given name exists.

    Attributes can be set two ways. The servlet container may set attributes to make available custom information about a request. For example, for requests made using HTTPS, the attribute `javax.servlet.request.X509Certificate` can be used to retrieve information on the certificate of the client. Attributes can also be set programatically using `ServletRequest.setAttribute(java.lang.String, java.lang.Object)`. This allows information to be embedded into a request before a `RequestDispatcher` call.

    Attribute names should follow the same conventions as package names. This specification reserves names matching `java.*`, `javax.*`, and `sun.*`.

    Specified by:
      `getAttribute` in interface `ServletRequest`
    Parameters:
      `name` - a `String` specifying the name of the attribute
    Returns:
      an `Object` containing the value of the attribute, or `null` if the attribute does not exist

  ### setAttribute

      public void setAttribute(java.lang.String name,
                               java.lang.Object value)

    Description copied from interface: `ServletRequest`
    Stores an attribute in this request. Attributes are reset between requests. This method is most often used in conjunction with `RequestDispatcher`.

    Attribute names should follow the same conventions as package names. Names beginning with `java.*`, `javax.*`, and `com.sun.*`, are reserved for use by Sun Microsystems.
    If the value passed in is null, the effect is the same as calling `ServletRequest.removeAttribute(java.lang.String)`.

    Specified by:
      `setAttribute` in interface `ServletRequest`
    Parameters:
      `name` - a `String` specifying the name of the attribute
      `value` - the `Object` to be stored

  ### removeAttribute

      public void removeAttribute(java.lang.String name)

    Description copied from interface: `ServletRequest`
    Removes an attribute from this request. This method is not generally needed as attributes only persist as long as the request is being handled.

    Attribute names should follow the same conventions as package names. Names beginning with `java.*`, `javax.*`, and `com.sun.*`, are reserved for use by Sun Microsystems.

    Specified by:
      `removeAttribute` in interface `ServletRequest`
    Parameters:
      `name` - a `String` specifying the name of the attribute to remove

  ### setCharacterEncoding

      public void setCharacterEncoding(java.lang.String encoding)
                                throws java.io.UnsupportedEncodingException

    Description copied from interface: `ServletRequest`
    Overrides the name of the character encoding used in the body of this request. This method must be called prior to reading request parameters or reading input using getReader().

    Specified by:
      `setCharacterEncoding` in interface `ServletRequest`
    Throws:
      `java.io.UnsupportedEncodingException` - if this is not a valid encoding

  ### getCharacterEncoding

      public java.lang.String getCharacterEncoding()

    Description copied from interface: `ServletRequest`
    Returns the name of the character encoding used in the body of this request. This method returns `null` if the request does not specify a character encoding

    Specified by:
      `getCharacterEncoding` in interface `ServletRequest`
    Returns:
      a `String` containing the name of the chararacter encoding, or `null` if the request does not specify a character encoding

  ### getContentLength

      public int getContentLength()

    Description copied from interface: `ServletRequest`
    Returns the length, in bytes, of the request body and made available by the input stream, or -1 if the length is not known. For HTTP servlets, same as the value of the CGI variable CONTENT_LENGTH.

    Specified by:
      `getContentLength` in interface `ServletRequest`
    Returns:
      an integer containing the length of the request body or -1 if the length is not known

  ### getContentType

      public java.lang.String getContentType()

    Description copied from interface: `ServletRequest`
    Returns the MIME type of the body of the request, or `null` if the type is not known. For HTTP servlets, same as the value of the CGI variable CONTENT_TYPE.

    Specified by:
      `getContentType` in interface `ServletRequest`
    Returns:
      a `String` containing the name of the MIME type of the request, or null if the type is not known

  ### getInputStream

      public ServletInputStream getInputStream()

    Description copied from interface: `ServletRequest`
    Retrieves the body of the request as binary data using a `ServletInputStream`. Either this method or `ServletRequest.getReader()` may be called to read the body, not both.

    Specified by:
      `getInputStream` in interface `ServletRequest`
    Returns:
      a `ServletInputStream` object containing the body of the request

  ### getParameterMap

      public java.util.Map getParameterMap()

    This method is not recommended as it forces the generation of a non-optimal data structure.

    Specified by:
      `getParameterMap` in interface `ServletRequest`
    Returns:
      an immutable java.util.Map containing parameter names as keys and parameter values as map values. The keys in the parameter map are of type String. The values in the parameter map are of type String array.

  ### getParameter

      public java.lang.String getParameter(java.lang.String name)

    Description copied from interface: `ServletRequest`
    Returns the value of a request parameter as a `String`, or `null` if the parameter does not exist. Request parameters are extra information sent with the request. For HTTP servlets, parameters are contained in the query string or posted form data.

    You should only use this method when you are sure the parameter has only one value. If the parameter might have more than one value, use `ServletRequest.getParameterValues(java.lang.String)`.

    If you use this method with a multivalued parameter, the value returned is equal to the first value in the array returned by `getParameterValues`.

    If the parameter data was sent in the request body, such as occurs with an HTTP POST request, then reading the body directly via `ServletRequest.getInputStream()` or `ServletRequest.getReader()` can interfere with the execution of this method.

    Specified by:
      `getParameter` in interface `ServletRequest`
    Parameters:
      `name` - a `String` specifying the name of the parameter
    Returns:
      a `String` representing the single value of the parameter
    See Also:
      `ServletRequest.getParameterValues(java.lang.String)`

  ### getParameterNames

      public java.util.Enumeration getParameterNames()

    Description copied from interface: `ServletRequest`
    Returns an `Enumeration` of `String` objects containing the names of the parameters contained in this request. If the request has no parameters, the method returns an empty `Enumeration`.

    Specified by:
      `getParameterNames` in interface `ServletRequest`
    Returns:
      an `Enumeration` of `String` objects, each `String` containing the name of a request parameter; or an empty `Enumeration` if the request has no parameters

  ### getParameterValues

      public java.lang.String[] getParameterValues(java.lang.String name)

    Description copied from interface: `ServletRequest`
    Returns an array of `String` objects containing all of the values the given request parameter has, or `null` if the parameter does not exist.

    If the parameter has a single value, the array has a length of 1.

    Specified by:
      `getParameterValues` in interface `ServletRequest`
    Parameters:
      `name` - a `String` containing the name of the parameter whose value is requested
    Returns:
      an array of `String` objects containing the parameter's values
    See Also:
      `ServletRequest.getParameter(java.lang.String)`

  ### getProtocol

      public java.lang.String getProtocol()

    Description copied from interface: `ServletRequest`
    Returns the name and version of the protocol the request uses in the form protocol/majorVersion.minorVersion, for example, HTTP/1.1. For HTTP servlets, the value returned is the same as the value of the CGI variable `SERVER_PROTOCOL`.

    Specified by:
      `getProtocol` in interface `ServletRequest`
    Returns:
      a `String` containing the protocol name and version number

  ### getScheme

      public java.lang.String getScheme()

    Description copied from interface: `ServletRequest`
    Returns the name of the scheme used to make this request, for example, `http`, `https`, or `ftp`. Different schemes have different rules for constructing URLs, as noted in RFC 1738.

    Specified by:
      `getScheme` in interface `ServletRequest`
    Returns:
      a `String` containing the name of the scheme used to make this request

  ### getServerName

      public java.lang.String getServerName()

    Description copied from interface: `ServletRequest`
    Returns the host name of the server that received the request. For HTTP servlets, same as the value of the CGI variable `SERVER_NAME`.

    Specified by:
      `getServerName` in interface `ServletRequest`
    Returns:
      a `String` containing the name of the server to which the request was sent

  ### getServerPort

      public int getServerPort()

    Description copied from interface: `ServletRequest`
    Returns the port number on which this request was received. For HTTP servlets, same as the value of the CGI variable `SERVER_PORT`.

    Specified by:
      `getServerPort` in interface `ServletRequest`
    Returns:
      an integer specifying the port number

  ### getReader

      public java.io.BufferedReader getReader()

    Description copied from interface: `ServletRequest`
    Retrieves the body of the request as character data using a `BufferedReader`. The reader translates the character data according to the character encoding used on the body. Either this method or `ServletRequest.getInputStream()` may be called to read the body, not both.

    Specified by:
      `getReader` in interface `ServletRequest`
    Returns:
      a `BufferedReader` containing the body of the request
    See Also:
      `ServletRequest.getInputStream()`

  ### getRemoteAddr

      public java.lang.String getRemoteAddr()

    Description copied from interface: `ServletRequest`
    Returns the Internet Protocol (IP) address of the client that sent the request. For HTTP servlets, same as the value of the CGI variable `REMOTE_ADDR`.

    Specified by:
      `getRemoteAddr` in interface `ServletRequest`
    Returns:
      a `String` containing the IP address of the client that sent the request

  ### getRemoteHost

      public java.lang.String getRemoteHost()

    Description copied from interface: `ServletRequest`
    Returns the fully qualified name of the client that sent the request. If the engine cannot or chooses not to resolve the hostname (to improve performance), this method returns the dotted-string form of the IP address. For HTTP servlets, same as the value of the CGI variable `REMOTE_HOST`.

    Specified by:
      `getRemoteHost` in interface `ServletRequest`
    Returns:
      a `String` containing the fully qualified name of the client

  ### getRealPath

      public java.lang.String getRealPath(java.lang.String path)

    Deprecated. As of Version 2.1 of the Java Servlet API, use `ServletContext.getRealPath(java.lang.String)` instead.

    Specified by:
      `getRealPath` in interface `ServletRequest`

  ### getRequestDispatcher

      public RequestDispatcher getRequestDispatcher(java.lang.String url)

    Description copied from interface: `ServletRequest`
    Returns a `RequestDispatcher` object that acts as a wrapper for the resource located at the given path. A `RequestDispatcher` object can be used to forward a request to the resource or to include the resource in a response. The resource can be dynamic or static.

    The pathname specified may be relative, although it cannot extend outside the current servlet context. If the path begins with a "/" it is interpreted as relative to the current context root. This method returns `null` if the servlet container cannot return a `RequestDispatcher`.

    The difference between this method and `ServletContext.getRequestDispatcher(java.lang.String)` is that this method can take a relative path.

    Specified by:
      `getRequestDispatcher` in interface `ServletRequest`
    Parameters:
      `url` - a `String` specifying the pathname to the resource
    Returns:
      a `RequestDispatcher` object that acts as a wrapper for the resource at the specified path
    See Also:
      `RequestDispatcher`, `ServletContext.getRequestDispatcher(java.lang.String)`

  ### toString

      public java.lang.String toString()

    Overrides:
      `toString` in class `java.lang.Object`

  ### unwrap

      public static ServletHttpRequest unwrap(ServletRequest request)

    Unwrap a ServletRequest.

    Parameters:
      `request` -
    Returns:
      The core ServletHttpRequest which must be the underlying request object
    See Also:
      `ServletRequestWrapper`, `HttpServletRequestWrapper`

  Copyright © 2000 Mortbay Consulting Pty. Ltd. All Rights Reserved.